package game.control;

import java.awt.event.KeyEvent;

public interface KeyboardControlConfiguration {

    public static final KeyboardControlConfiguration STANDARD_CONFIGURATION = new KeyboardControlConfiguration() {

        @Override
        public int down() {
            return KeyEvent.VK_DOWN;
        }

        @Override
        public int fire() {
            return KeyEvent.VK_SPACE;
        }

        @Override
        public int left() {
            return KeyEvent.VK_LEFT;
        }

        @Override
        public int pause() {
            return KeyEvent.VK_ESCAPE;
        }

        @Override
        public int right() {
            return KeyEvent.VK_RIGHT;
        }

        @Override
        public int secondaryFire() {
            return KeyEvent.VK_F;
        }

        @Override
        public int up() {
            return KeyEvent.VK_UP;
        }
    };

    public int down();

    public int fire();

    public int left();

    public int pause();

    public int right();

    public int secondaryFire();

    public int up();
}
