package game.control;

import game.objects.Creature;
import game.objects.Entity;
import geometry.Point2D;

import java.util.ArrayList;

public class MapNode {

    protected ArrayList<Entity> entities;
    protected ArrayList<MapNode> neighbours;
    protected Point2D position;

    public MapNode(Point2D position) {
        this.position = position;
        this.entities = new ArrayList<Entity>();
        this.neighbours = new ArrayList<MapNode>();
    }

    public boolean isAccessible(Creature creature) {
        return true;
    }

    public void addEntity(Entity e) {
        entities.add(e);
    }

    public void addNeighbour(MapNode neighbour) {
        neighbours.add(neighbour);
        neighbour.neighbours.add(this);
    }

    public Point2D getPosition() {
        return position;
    }

    public int numEntity() {
      return entities.size();	
    }
    
    public boolean hasEntity(Entity e) {
        return entities.contains(e);
    }

    public ArrayList<MapNode> neighbours() {
        return neighbours;
    }

    public void removeEntity(Entity e) {
        entities.remove(e);
    }
}
