package geometry;

public class Circle {

    private Point2D center;

    private double radius;

    public Circle(Point2D center, double radius) {
        this.center = center;
        this.radius = radius;
    }

    public double distance(Circle c) {
        return center.distance(c.center) - this.radius - c.radius;
    }

    public double getArea() {
        return Math.pow(this.radius, 2) * Math.PI;
    }

    public Point2D getCenter() {
        return this.center;
    }

    public double getCircumference() {
        return 2 * this.radius * Math.PI;
    }

    public double getRadius() {
        return this.radius;
    }

    public void setCenter(Point2D center) {
        this.center = center;
    }

    public void setRadius(double radius) {
        this.radius = radius;
    }
}
