package pacman;

import game.Game;
import game.GameUpdate;
import game.control.KeyboardControl;
import game.control.MapNode;
import game.objects.Creature;
import geometry.Vector2D;

import java.awt.event.KeyEvent;

public class PacManKeyboardControl extends KeyboardControl {

	private int current_key;

	public PacManKeyboardControl(Game game, Creature controlledCreature) {
		super(game, controlledCreature);
		current_key = 0;
	}

	private void lastDirectionKey() {
		for (int i = keyEvents.size() - 1; i >= 0; --i) {
			KeyEvent current = keyEvents.get(i);
			if ((current.getID() == KeyEvent.KEY_PRESSED || current.getID() == KeyEvent.KEY_TYPED)
					&& (current.getKeyCode() == configuration.down()
							|| current.getKeyCode() == configuration.left()
							|| current.getKeyCode() == configuration.right() || current
							.getKeyCode() == configuration.up())) {
				current_key = current.getKeyCode();
			}
		}
		keyEvents.clear();
	}

	@Override
	protected void targetNodeReached() {

		lastDirectionKey();

		boolean stop = true;

		controlledCreature.setPosition(targetNode.getPosition());

		boolean turned = false;
		for (MapNode node : targetNode.neighbours()) {

			Vector2D targetVector = node.getPosition().subtract(
					targetNode.getPosition());

			Vector2D targetVectorNormalized = targetVector.normalized();
			if (current_key == configuration.up()
					&& (int) Math.round(targetVectorNormalized.getX()) == 0
					&& (int) Math.round(targetVectorNormalized.getY()) == -1) {
				stop = false;
				setTargetNode(node);
				controlledCreature.setDirection(targetVectorNormalized);
				turned = true;
				break;
			} else if (current_key == configuration.down()
					&& (int) Math.round(targetVectorNormalized.getX()) == 0
					&& (int) Math.round(targetVectorNormalized.getY()) == 1) {
				stop = false;
				setTargetNode(node);
				controlledCreature.setDirection(targetVectorNormalized);
				turned = true;
				break;
			} else if (current_key == configuration.left()
					&& (int) Math.round(targetVectorNormalized.getX()) == -1
					&& (int) Math.round(targetVectorNormalized.getY()) == 0) {
				stop = false;
				setTargetNode(node);
				controlledCreature.setDirection(targetVectorNormalized);
				turned = true;
				break;
			} else if (current_key == configuration.right()
					&& (int) Math.round(targetVectorNormalized.getX()) == 1
					&& (int) Math.round(targetVectorNormalized.getY()) == 0) {
				stop = false;
				setTargetNode(node);
				controlledCreature.setDirection(targetVectorNormalized);
				turned = true;
				break;
			}
		}

		if (!turned) {
			for (MapNode node : targetNode.neighbours()) {
				Vector2D targetVector = node.getPosition().subtract(
						targetNode.getPosition());
				Vector2D targetVectorNormalized = targetVector.normalized();

				if ((int) Math.round(targetVectorNormalized.getX()) == (int) Math
						.round(controlledCreature.getDirection().getX())
						&& (int) Math.round(targetVectorNormalized.getY()) == (int) Math
								.round(controlledCreature.getDirection().getY())) {
					stop = false;
					setTargetNode(node);
					break;
				}
			}
		}

		if (stop) {
			controlledCreature.setDirection(new Vector2D(0, 0));
		}
	}

	@Override
	public void update(GameUpdate update) {
		super.update(update);
	}
}
